package org.onis.secu3;

import org.onis.secu3.manager.R;

import android.content.Context;
import android.text.TextWatcher;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

public class MyPlusMinusControl extends LinearLayout {
	EditText mEditText;
	Button mButtonMinus, mButtonPlus;
	
	private MyPlusMinusControlChangeListener _listener=null;
	
	// Define our custom Listener interface
	//   
	public interface MyPlusMinusControlChangeListener {
		public abstract  void OnChanged();
	}
	
	
	// Allows the user to set an Listener and react to the event
	//       
	public void setOnChangeListener(MyPlusMinusControlChangeListener l) {
		this._listener = l; 
	}
	
	
	//  
	private void OnChangedRaise(){
	    // Check if the Listener was set, otherwise we'll get an Exception when we try to call it
	    if(_listener!=null) {
	        //trigger the event
	    	_listener.OnChanged();
	    }
	}

	
	
	//     
	private double maxValue=30;
	private double minValue=-30;
	private double Step=0.25; //    
	private double Value=0;
	
	/**
	 * @return the value
	 */
	public double getValue() {
		return Value;
	}
	/**
	 * @param value the value to set
	 */
	public void setValue(double value) {
		this.Value = ((value<=maxValue && value>=minValue)?value:((value<=minValue)?minValue:maxValue));
		mEditText.setText(Double.toString(this.Value));
		//     
		OnChangedRaise();
	}
	/**
	 * @return the mixCount
	 */
 	public double getminValue() {
		return minValue;
	}
	/**
	 * @param mixCount the mixCount to set
	 */
	public void setminValue(double minValue) {
		this.minValue = minValue;
	}
	/**
	 * @return the maxCount
	 */
	public double getMaxValue() {
		return maxValue;
	}
	/**
	 * @param maxCount the maxCount to set
	 */
	public void setMaxValue(double maxCount) {
		this.maxValue = maxCount;
	}
	/**
	 * @return the step
	 */
	public double getStep() {
		return Step;
	}
	/**
	 * @param step the step to set
	 */
	public void setStep(double step) {
		this.Step = step;
	}


	public MyPlusMinusControl(Context context, AttributeSet attrs) {
		super(context, attrs);
		//      .
		String infService = Context.LAYOUT_INFLATER_SERVICE;
		LayoutInflater li;
		li = (LayoutInflater)getContext().getSystemService(infService);
		li.inflate(R.layout.plusminuscount, this, true);
		//     .
		
		mEditText = (EditText)findViewById(R.id.TextEditValue);
		mButtonMinus = (Button)findViewById(R.id.buttonMinus);
		mButtonPlus = (Button)findViewById(R.id.buttonPlus);
		//  
		setValue(0);
		
		//mButtonPlus.setOnClickListener(buttonPlusListener);
		//mButtonMinus.setOnClickListener(buttonMinusListener);
		this.ButtonMinus();
		this.ButtonPlus();
		
		/*
		mEditText.addTextChangedListener(new TextWatcher() {    
			public void afterTextChanged(View v) {
		        if (_listener != null)
		            _listener.onClick(MyPlusMinusControl.this);
		    }
		});
		*/
	}
	
	
	private void ButtonMinus() {
		// TODO Auto-generated method stub
		mButtonMinus.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				mEditText.setText(Double.toString(11));
				setValue(Value-Step);
				//Log.i("ButtonPlus","ButtonMinus");
			}
			});
	}
	private void ButtonPlus() {
		// TODO Auto-generated method stub
		mButtonPlus.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				setValue(Value+Step);
				//Log.i("ButtonPlus","ButtonPlus " + Double.toHexString(Value-Step));
			}
			});
	}
}
