
package org.onis.secu3;

import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.text.DecimalFormat;

import org.onis.secu3.MyPlusMinusControl.MyPlusMinusControlChangeListener;
import org.onis.secu3.manager.R;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.PowerManager;
import android.os.SystemClock;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

public class SECU3Manager extends Activity implements  Button.OnClickListener{
	
	//  UI
	private Handler mHandlerToUpdteUI = new Handler(); 
	
	
	
	//  
	public static final char   CHANGEMODE  = 'h';   //!< change mode (type of default packet)
	public static final char   BOOTLOADER  = 'i';   //!< start boot loader
	public static final char   TEMPER_PAR  = 'j';   //!< temperature parameters (coolant sensor, engine cooling etc)
	public static final char   CARBUR_PAR  = 'k';   //!< carburetor's parameters
	public static final char   IDLREG_PAR  = 'l';   //!< idling regulator parameters
	public static final char   ANGLES_PAR  = 'm';   //!< advance angle (ign. timing) parameters
	public static final char   FUNSET_PAR  = 'n';   //!< parametersrelated to set of functions (lookup tables)
	public static final char   STARTR_PAR  = 'o';   //!< engine start parameters
	public static final char   FNNAME_DAT  = 'p';   //!< used for transfering of names of set of functions (lookup tables)
	public static final char   SENSOR_DAT  = 'q';   //!< used for transfering of sensors data
	public static final char   ADCCOR_PAR  = 'r';   //!< parameters related to ADC corrections
	public static final char   ADCRAW_DAT  = 's';   //!< used for transfering 'raw' values directly from ADC
	public static final char   CKPS_PAR    = 't';   //!< CKP sensor parameters
	public static final char   OP_COMP_NC  = 'u';   //!< used to indicate that specified (suspended) operation completed
	public static final char   CE_ERR_CODES= 'v';   //!< used for transfering of CE codes
	public static final char   KNOCK_PAR   = 'w';   //!< parameters related to knock detection and knock chip
	public static final char   CE_SAVED_ERR= 'x';   //!< used for transfering of CE codes stored in the EEPROM
	public static final char   FWINFO_DAT  = 'y';   //!< used for transfering information about firmware
	public static final char   MISCEL_PAR  = 'z';   //!< miscellaneous parameters
	public static final char   EDITAB_PAR  = '{';   //!< used for transferring of data for realtime tables editing
	public static final char   ATTTAB_PAR  = '}';   //!< used for transferring of attenuator map (knock detection related)
	public static final char   DBGVAR_DAT  = ':';   //!< for watching of firmware variables (used for debug purposes)
	public static final char   DIAGINP_DAT = '=';   //!< diagnostics: send input values (analog & digital values)
	public static final char   DIAGOUT_DAT = '^';   //!< diagnostics: receive output states (bits)

	/*    -  */
	public static final int MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER = 64;
	/*    -  */
	public static final int UBAT_PHYSICAL_MAGNITUDE_MULTIPLAYER = 400;
	/*    -  */
	public static final int TEMP_PHYSICAL_MAGNITUDE_MULTIPLAYER = 4;
	/*    */
	public static final float ADC_DISCRETE = (float) 0.0025;
	/*    , 
	             2) */
	public static final int	ANGLE_MULTIPLAYER = 32;
	public static final int TPS_PHYSICAL_MAGNITUDE_MULTIPLAYER = 2;
	public static final int CHOKE_PHYSICAL_MAGNITUDE_MULTIPLAYER = 2;
	//   OP_COMP_NC
	public static final int OPCODE_EEPROM_PARAM_SAVE    = 1;
	public static final int OPCODE_CE_SAVE_ERRORS       = 2;
	public static final int OPCODE_READ_FW_SIG_INFO     = 3;
	public static final int OPCODE_LOAD_TABLSET         = 4;  //realtime tables
	public static final int OPCODE_SAVE_TABLSET         = 5;  //realtime tables
	public static final int OPCODE_DIAGNOST_ENTER       = 6;  //enter diagnostic mode
	public static final int OPCODE_DIAGNOST_LEAVE       = 7;  //leave diagnostic mode
	public static final int OPCODE_RESET_EEPROM         = 0xCF;//reset EEPROM
	//       SENSOR_DAT
	public class SENSOR_DAT {
		 int   RPM=0; 	//    (, -1)
		 float MAP=0; 	//     (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		 float UBAT=0;	//   ( * UBAT_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		 float TEMP=0; 	//   ( C * TEMP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		 float AA=0; 	//  ( * ANGLE_MULTIPLAYER)
		 float KNOCK=0;  //     HIP9011      (   )
		 float KNOCK_AA_CORR=0; //   ,  0    ( * ANGLE_MULTIPLAYER)
		 int AIR=0;	//  (016), 0   	
		 byte  BIT_FLAGS_SENSORS=0; /*   .
									0     (1- , 0- )
									1     (1-, 0-)
									2     (1-, 0- )
									3     (1-, 0- )
									4     (1-, 0-)*/
		//   
		//0   
		 int IE=0; //0     (!0- , 0- )
		 int CARB=0; //1     (!0-, 0-)
		 int GAS_KLAPAN=0; //2     (!0-, 0- )
		 int FE=0; //3     (!0-, 0- )
		 int CE=0; //4     (!0-, 0-)
		 final int length = 50; //   /r
		 //  
		 boolean isReaded=false; //        
	}
	//       ANGLES_PAR
	public class ANGLES_PAR {
		 float MAX_ANGLE=0; //  ( * ANGLE_MULTIPLAYER)
		 float MIN_ANGLE=0; //  ( * ANGLE_MULTIPLAYER)
		 float OCTAN_CORR=0; //  ( * ANGLE_MULTIPLAYER)
		 float SPEED_SLOWER_ANGLE=0; //  , ./ ( * ANGLE_MULTIPLAYER)
		 float SPEED_FASTER_ANGLE=0; //  , ./ ( * ANGLE_MULTIPLAYER)
		 int ZERO_ANGLE=0; // 0-   (0,1),    1      0
		 final int length = 23; //   /r
		 //  
		 boolean isReaded=false; //        
	}
	//      
	public class FNNAME_DAT {
		 int F_COUNT=0; //AA	     
		 int F_NUMBER=0; //BB	  
		 String [] F_NAME={"NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL","NULL"}; //(name)      (16 ASCII )
		 final int length = 22; //   /r
		 //  
		//     
		 boolean [] isReadedArray = {false,false,false,false,false,false,false,false,false,false}; //     
		 boolean isReaded=false; //          
	}
	//         
	public class FUNSET_PAR {
		 int CURR_F_B=0; //AA	     
		 int CURR_F_G=0; //BB	     
		 float MIN_MAP=0; //CCCC	      (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		 float MAX_MAP=0; //DDDD	      (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		 float SMESHENIE_MAP=0; //EEEE	     (   )
		 float NAKLON_MAP=0; //FFFF	   (/,  * (128 * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER *  ))
		 float tps_curve_offset=0;  // 
		 float tps_curve_gradient=0; // 
		 final int length = 30; //   /r;
		 //  
		 boolean isReaded=false; //        
	}
	
	//         
	public class OP_COMP_NC              
	 {
	  byte opcode;   //operation code
	  byte opdata;   //operation data
	  //  
	  boolean isReaded=false; //        
	  public int length = 6; //   /r;
	 }
	
	// Message types sent from the BluetoothRfcommClient Handler
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;
	// Key names received from the BluetoothRfcommClient Handler
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";
    // Intent request codes
    private static final int REQUEST_CONNECT_DEVICE = 1;
    private static final int REQUEST_ENABLE_BT = 2;
	
    // Layout Views
    private TextView mBTStatus;
    private TextView mTextViewBatteyValue;
    private TextView mTextViewTempValue;
    private TextView mViewAdvanceAngle;
    private TextView mtextViewAirFlow;
    private ProgressBar mProgressBarMAP;
    private Spinner mspinnerSelectMap;
    private MyPlusMinusControl myPlusMinusControl1;
    public WaveformView mWaveform = null;
    
    // Name of the connected device
    private String mConnectedDeviceName = null;
    // Local Bluetooth adapter
    private BluetoothAdapter mBluetoothAdapter = null;
    // Member object for the RFCOMM services
    private BluetoothRfcommClient mRfcommClient = null;

    //        
    private SENSOR_DAT mSENSOR_DAT = new SENSOR_DAT();
    private ANGLES_PAR mANGLES_PAR = new ANGLES_PAR();
    private FNNAME_DAT mFNNAME_DAT = new FNNAME_DAT();
    private FUNSET_PAR mFUNSET_PAR = new FUNSET_PAR();
    private OP_COMP_NC mOP_COMP_NC = new OP_COMP_NC();
    
    // stay awake
    protected PowerManager.WakeLock mWakeLock;
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    	
        //   
    	mRfcommClient = (BluetoothRfcommClient) getLastNonConfigurationInstance();
        
    	mBTStatus = (TextView) findViewById(R.id.txt_btstatus);
    	
    	//mBTStatus.setText(getString(mBTStatus.hashCode()));
    	mTextViewBatteyValue = (TextView) findViewById(R.id.textViewBatteryValue);
    	mTextViewTempValue = (TextView) findViewById(R.id.textViewTempValue);
        mViewAdvanceAngle = (TextView) findViewById(R.id.textViewAdvanceAngle);
        mtextViewAirFlow = (TextView) findViewById(R.id.textViewAirFlow);   	
        mProgressBarMAP = (ProgressBar) findViewById(R.id.progressBarMAP);
        mspinnerSelectMap = (Spinner) findViewById(R.id.spinnerSelectMap);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, mFNNAME_DAT.F_NAME);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        mspinnerSelectMap.setAdapter(adapter);
        myPlusMinusControl1 = (MyPlusMinusControl) findViewById(R.id.myPlusMinusControl1);
        //    
        myPlusMinusControl1.setOnChangeListener(new MyPlusMinusControlChangeListener() {    
			@Override
			public void OnChanged() {
				//   
				//     
				Log.i("OnChanged",Double.toString(myPlusMinusControl1.getValue()));
				set_oktan_corr(myPlusMinusControl1.getValue());
			}
        });
        
        //    
        mspinnerSelectMap.setOnItemSelectedListener(new OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                int position, long id) {
              //    
              set_Map(position);
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
          });

        //mWaveform = new WaveformView(this);
        mWaveform = (WaveformView)findViewById(R.id.waveformView1); 
        
        // Get local Bluetooth adapter
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        
        // If the adapter is null, then Bluetooth is not supported
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
            finish();
            return;
        }
        
        // Prevent phone from sleeping
        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        this.mWakeLock = pm.newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK, "My Tag"); 
        this.mWakeLock.acquire();
        
        
        //  UI
        mHandlerToUpdteUI.removeCallbacks(mUpdateTimeTask);
        mHandlerToUpdteUI.postDelayed(mUpdateTimeTask, 100);
        
        
        
    }
    
    @Override
    public void onStart(){
    	super.onStart();

    	// If BT is not on, request that it be enabled.
    	if (!mBluetoothAdapter.isEnabled()){
    		Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
    		startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
    	}
    	// Otherwise, setup the Manager session
    	else{
    		if (mRfcommClient == null) 
    			//Initialize the BluetoothRfcommClient to perform bluetooth connections
    			mRfcommClient = new BluetoothRfcommClient(this, mHandler);
    	}    	
    }

    @Override
    public synchronized void onResume(){
    	super.onResume();
    	// Performing this check in onResume() covers the case in which BT was
        // not enabled during onStart(), so we were paused to enable it...
        // onResume() will be called when ACTION_REQUEST_ENABLE activity returns.
        if (mRfcommClient != null) {
            // Only if the state is STATE_NONE, do we know that we haven't started already
            if (mRfcommClient.getState() == BluetoothRfcommClient.STATE_NONE) {
              // Start the Bluetooth  RFCOMM services
              mRfcommClient.start();
            }
        }
    }
    
    public void  onClick(View v){
    	int buttonID;
    	buttonID = v.getId();
    	String Todisplay="____";
    	switch (buttonID){
    	case R.id.btn_position_up :
    		//inc_oktan_corr();
    		//mANGLES_PAR.OCTAN_CORR+=1;
    		// Todisplay = HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.OCTAN_CORR*ANGLE_MULTIPLAYER)));
    		//mtextViewTest.setText("@"+ANGLES_PAR+Todisplay+'\r');
    		break;
    	case R.id.btn_position_down :
    		//dec_oktan_corr();
    		//mANGLES_PAR.OCTAN_CORR-=1;
    		// Todisplay = HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.OCTAN_CORR*ANGLE_MULTIPLAYER)));
    		//mtextViewTest.setText("@"+ANGLES_PAR+Todisplay+'\r');
    		break;
    	case R.id.myPlusMinusControl1 :
    		Log.i("myPlusMinusControl1",Double.toHexString(myPlusMinusControl1.getValue()));
    		break;


    	}
    }

    public BluetoothRfcommClient onRetainNonConfigurationInstance() {
        return mRfcommClient;
      }
    
    @Override
    public void onDestroy(){
    	super.onDestroy();
    	// Stop the Bluetooth RFCOMM services
       // if (mRfcommClient != null) mRfcommClient.stop();
        // release screen being on
    	//    
        if (mWakeLock.isHeld()) { 
            mWakeLock.release();
        }
    }
        
    /**
     * Sends a message.
     * @param message  A string of text to send.
     */
    private void sendMessage(String message){
    	//TODO    
    	if (mRfcommClient!=null){
    	    // Check that we're actually connected before trying anything
	    	if (mRfcommClient.getState() != BluetoothRfcommClient.STATE_CONNECTED) {
	    		Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
	    		return;
	    	}
	    	// Check that there's actually something to send
	    	if (message.length() > 0) {
	    		// Get the message bytes and tell the BluetoothRfcommClient to write
	    		byte[] send = message.getBytes();
	    		mRfcommClient.write(send);
	    	}
    	}

    }
    
    private void BTConnect(){
    	Intent serverIntent = new Intent(this, DeviceListActivity.class);
    	startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
    }
      
    //  
    private void set_context(char CONTEXT)
    {
    	//    
    	sendMessage("!"+CHANGEMODE+CONTEXT+'\r');
    }
    
    private void read_values_from_context(String str){
    	//   (,    + 
    	//        

    	char[] desc=str.toCharArray();
    	
    	 switch (desc[1]){
    		 case SENSOR_DAT:
	    			//Log.i("SENSOR_DAT",Integer.toString(desc.length) + " " + str);
	    			if (desc.length==mSENSOR_DAT.length) {
		    			mSENSOR_DAT.RPM=hex2SignedInt(str,2,6); 	//    (, -1)
						mSENSOR_DAT.MAP=(float)hex2SignedInt(str,6,10)/MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER; 	//     (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
						mSENSOR_DAT.UBAT=(float)hex2SignedInt(str,10,14)/UBAT_PHYSICAL_MAGNITUDE_MULTIPLAYER;	//   ( * UBAT_PHYSICAL_MAGNITUDE_MULTIPLAYER)
						mSENSOR_DAT.TEMP=(float)hex2SignedInt(str,14,18)/TEMP_PHYSICAL_MAGNITUDE_MULTIPLAYER; 	//   ( C * TEMP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
						mSENSOR_DAT.AA=(float)hex2SignedInt(str,18,22)/ANGLE_MULTIPLAYER; 	//  ( * ANGLE_MULTIPLAYER)
						mSENSOR_DAT.KNOCK=(float)hex2SignedInt(str,22,26)*ADC_DISCRETE;  //     HIP9011      (   )
						mSENSOR_DAT.KNOCK_AA_CORR=(float)hex2SignedInt(str,26,30)/ANGLE_MULTIPLAYER; //   ,  0    ( * ANGLE_MULTIPLAYER)
						mSENSOR_DAT.AIR=hex2SignedInt(str,30,32);	//  (016), 0   	
						mSENSOR_DAT.BIT_FLAGS_SENSORS=(byte)Integer.parseInt(str.substring(32,33),16);	
						/*   .
														0     (1- , 0- )
														1     (1-, 0-)
														2     (1-, 0- )
														3     (1-, 0- )
														4     (1-, 0-)*/
						mSENSOR_DAT.IE=(mSENSOR_DAT.BIT_FLAGS_SENSORS&1); //0     (1- , 0- )
						mSENSOR_DAT.CARB=(mSENSOR_DAT.BIT_FLAGS_SENSORS&2); //1     (1-, 0-)
						mSENSOR_DAT.GAS_KLAPAN=(mSENSOR_DAT.BIT_FLAGS_SENSORS&4); //2     (1-, 0- )
						mSENSOR_DAT.FE=(mSENSOR_DAT.BIT_FLAGS_SENSORS&8); //3     (1-, 0- )
						mSENSOR_DAT.CE=(mSENSOR_DAT.BIT_FLAGS_SENSORS&16); //4     (1-, 0-)
						//TODO   
    			}
    			
				break;
				
    		 case ANGLES_PAR:
    			//     
    			 if (mANGLES_PAR.isReaded==false){
					 Log.i("ANGLES_PAR",Integer.toString(desc.length) + " " + str);
	    			 if (desc.length==mANGLES_PAR.length) {
		    			 mANGLES_PAR.MAX_ANGLE=(float)hex2SignedInt(str,2,6)/ANGLE_MULTIPLAYER; //  ( * ANGLE_MULTIPLAYER)
		    			 mANGLES_PAR.MIN_ANGLE=(float)hex2SignedInt(str,6,10)/ANGLE_MULTIPLAYER;  //  ( * ANGLE_MULTIPLAYER)
		    			 mANGLES_PAR.OCTAN_CORR=(float)hex2SignedInt(str,10,14)/ANGLE_MULTIPLAYER; //  ( * ANGLE_MULTIPLAYER)
		    			 mANGLES_PAR.SPEED_SLOWER_ANGLE=(float)hex2SignedInt(str,14,18)/ANGLE_MULTIPLAYER; //  , ./ ( * ANGLE_MULTIPLAYER)
		    			 mANGLES_PAR.SPEED_FASTER_ANGLE=(float)hex2SignedInt(str,18,22)/ANGLE_MULTIPLAYER; //  , ./ ( * ANGLE_MULTIPLAYER)
		    			 mANGLES_PAR.ZERO_ANGLE=hex2SignedInt(str,22,23); // 0-   (0,1),    1      0
		    			 //   
		    			 mANGLES_PAR.isReaded=true;
		    		 }
    			 }
    			 break;
    		 case FNNAME_DAT:
    			 Log.i("FNNAME_DAT",Integer.toString(desc.length) + " " + str);
     			//     
    			 
    			 if (mFNNAME_DAT.isReaded==false){
	    			 if (desc.length==mFNNAME_DAT.length) {
		    			 mFNNAME_DAT.F_COUNT=Integer.parseInt(str.substring(2,4),16);
		    			 mFNNAME_DAT.F_NUMBER=Integer.parseInt(str.substring(4,6),16);
		    			 mFNNAME_DAT.F_NAME[mFNNAME_DAT.F_NUMBER]=str.substring(6,22);
		    			 mFNNAME_DAT.isReadedArray[mFNNAME_DAT.F_NUMBER]=true;
		    			 boolean allreadOk;
		    			 allreadOk=true;
		    			 //         
		    			 for (int i=0; i<10; i++)
		    			 {
		    				 //Log.i("FNNAME_DAT",Boolean.toString(mFNNAME_DAT.isReadedArray[i]));
		    				 if (mFNNAME_DAT.isReadedArray[i]==false) {
		    					 allreadOk=false;
		    				 }
		    			 }
		    			 if (allreadOk==true) {
		    				 mFNNAME_DAT.isReaded=true;
		    			 }
		    		 }
    			 }
    			 break;
    		 case OP_COMP_NC:
    			 //     
    			 if (mOP_COMP_NC.isReaded==false){
	    			 Log.i("OP_COMP_NC", str+ "  " + Integer.toString(desc.length) );
	    			 if (desc.length==mOP_COMP_NC.length ) {
	    				 mOP_COMP_NC.opdata=(byte) Integer.parseInt(str.substring(2,4),16); //AA   
	    				 mOP_COMP_NC.opcode=(byte) Integer.parseInt(str.substring(4,6),16); //AA  
		    			 //   
		    			 mOP_COMP_NC.isReaded=true;
		    		 }
    			 }
    			 break;
    		 case FUNSET_PAR:
    			 //     
    			 if (mFUNSET_PAR.isReaded==false){
	    			 Log.i("FUNSET_PAR",str+ "  " + Integer.toString(desc.length) );
	    			 if (desc.length==mFUNSET_PAR.length) {
		    			 mFUNSET_PAR.CURR_F_B=Integer.parseInt(str.substring(2,4),16); //AA	     
		    			 mFUNSET_PAR.CURR_F_G=Integer.parseInt(str.substring(4,6),16); //BB	     
		    			 mFUNSET_PAR.MIN_MAP=(float)Integer.parseInt(str.substring(6,10),16)/MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER; //CCCC	      (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		    			 mFUNSET_PAR.MAX_MAP=(float)Integer.parseInt(str.substring(10,14),16)/MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER; //DDDD	      (  * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)
		    			 mFUNSET_PAR.SMESHENIE_MAP=(float)Integer.parseInt(str.substring(14,18),16)*ADC_DISCRETE; //EEEE	     (   )
		    			 mFUNSET_PAR.NAKLON_MAP=(float)Integer.parseInt(str.substring(18,22),16)/(MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER*ADC_DISCRETE*128); //FFFF	   (/,  * (128 * MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER *  ))
		    			 mFUNSET_PAR.tps_curve_offset=(float)Integer.parseInt(str.substring(22,26),16)*ADC_DISCRETE;  // 
		    			 mFUNSET_PAR.tps_curve_gradient=(float)Integer.parseInt(str.substring(26,30),16)/((TPS_PHYSICAL_MAGNITUDE_MULTIPLAYER*64)*128*ADC_DISCRETE); // 
		    			 //   
		    			 mFUNSET_PAR.isReaded=true;
		    		 }
    			 }
    			 break;
    	 };
    	
    }
    
    // The Handler that gets information back from the BluetoothRfcommClient
    private final Handler mHandler = new Handler(){
    	@Override
        public void handleMessage(Message msg){
    		switch (msg.what){
    		case MESSAGE_STATE_CHANGE:
    			switch (msg.arg1){
    			case BluetoothRfcommClient.STATE_CONNECTED:
    				mBTStatus.setText(R.string.title_connected_to);
                    mBTStatus.append("\n" + mConnectedDeviceName);
                    // ,     
                    InitAfterConnect mInitAfterConnect = new InitAfterConnect();
                    mInitAfterConnect.execute();
    				break;
    			case BluetoothRfcommClient.STATE_CONNECTING:
    				mBTStatus.setText(R.string.title_connecting);
    				break;
    			case BluetoothRfcommClient.STATE_NONE:
    				mBTStatus.setText(R.string.title_not_connected);
    				break;
    			}
    			break;
    		case MESSAGE_READ: // todo: implement receive data buffering
    			byte[] readBuf = (byte[]) msg.obj;
    			char[] UnicodeChar = new char[readBuf.length];
    			//    char Unicode
    			for (int i=0; i<readBuf.length; i++){
    				UnicodeChar[i] = DecodeCP866toUnicode(readBuf[i]);
       			}
    			
    			String string_from_secu=new String(UnicodeChar);

    			//     
    			read_values_from_context(string_from_secu);
    			
    			//    
    			mWaveform.set_data(mSENSOR_DAT.RPM);
    			
    			//TODO   UI   
    			
    			//   
    			/*
    			mProgressBarMAP.setProgress(mSENSOR_DAT.AIR);
    			mtextViewAirFlow.setText("Air Flow(" + Integer.toString(mSENSOR_DAT.AIR) + ")");
    			
    			//     2-    ()
    			DecimalFormat df2 = new DecimalFormat("#0.00");
    			//mtextViewTest.setText(Float.toString(mSENSOR_DAT.UBAT)+" V\r"+Float.toString(mSENSOR_DAT.TEMP)+" C");
    			mTextViewBatteyValue.setText(df2.format(mSENSOR_DAT.UBAT)+" V");
    			mTextViewTempValue.setText(df2.format(mSENSOR_DAT.TEMP)+" C");
    			mViewAdvanceAngle.setText(df2.format(mSENSOR_DAT.AA)+"");
    			*/
    			break;
    		case MESSAGE_DEVICE_NAME:
    			// save the connected device's name
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                Toast.makeText(getApplicationContext(), "Connected to "
                        + mConnectedDeviceName, Toast.LENGTH_SHORT).show();
    			break;
    		case MESSAGE_TOAST:
    			Toast.makeText(getApplicationContext(), msg.getData().getString(TOAST),
                        Toast.LENGTH_SHORT).show();
    			break;
    		}
    	}

    };
    
    //        
    public void onActivityResult(int requestCode, int resultCode, Intent data){
    	switch (requestCode) {
    	case REQUEST_CONNECT_DEVICE:
    		// When DeviceListActivity returns with a device to connect
    		if (resultCode == Activity.RESULT_OK){
    			// Get the device MAC address
    			String address = data.getExtras().getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
    			// Get the BLuetoothDevice object
                BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
                // Attempt to connect to the device
                mRfcommClient.connect(device);
    		}
    		break;
    	case REQUEST_ENABLE_BT:
    		// When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK){
            	// Bluetooth is now enabled, so set up the Manager
    			//Initialize the BluetoothRfcommClient to perform bluetooth connections
    			mRfcommClient = new BluetoothRfcommClient(this, mHandler);
            }
            else{
            	// User did not enable Bluetooth or an error occured
                Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                finish();
            }
    		break;
    	}
    }

    protected void set_oktan_corr (double oktan){
    	//       
    	String toSend="";
    	toSend="!"+ANGLES_PAR+
    			HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.MAX_ANGLE*ANGLE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.MIN_ANGLE*ANGLE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(oktan*ANGLE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.SPEED_SLOWER_ANGLE*ANGLE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(mANGLES_PAR.SPEED_FASTER_ANGLE*ANGLE_MULTIPLAYER)))+
    			HexStringTo1Len(Integer.toHexString((int)(mANGLES_PAR.ZERO_ANGLE)))+
    			'\r';
    	if ((toSend.length())==(mANGLES_PAR.length+1)) {
    		sendMessage(toSend);
    	}
    	Log.i("set_oktan_corr",toSend + "  " + Integer.toString(toSend.length()));
    }
    
    
    protected void set_Map (int numberMap){
    	//       
    	String toSend="";
    	toSend="!"+FUNSET_PAR+
    			HexStringTo2Len(Integer.toHexString((int)(numberMap)))+
    			HexStringTo2Len(Integer.toHexString((int)(mFUNSET_PAR.CURR_F_G)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.MIN_MAP*MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.MAX_MAP*MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.SMESHENIE_MAP/ADC_DISCRETE)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.NAKLON_MAP*MAP_PHYSICAL_MAGNITUDE_MULTIPLAYER*ADC_DISCRETE*128)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.tps_curve_offset/ADC_DISCRETE)))+
    			HexStringTo4Len(Integer.toHexString((int)(mFUNSET_PAR.tps_curve_gradient*TPS_PHYSICAL_MAGNITUDE_MULTIPLAYER*64*ADC_DISCRETE*128)))+
    			'\r';
    	//TODO             
    	if ((toSend.length())==(mFUNSET_PAR.length+1)) {
    		sendMessage(toSend);
    	}
    	Log.i("FUNSET_PAR",toSend + "  " + Integer.toString(toSend.length()));
    }
    
    
protected String HexStringTo4Len(String str){
		
    	
    	if (str.length()>4)
    	{
    		str=str.substring(str.length()-4,str.length());
    	}
    	switch (str.length()){
    		case 0:
    			str= "0000";	    	
    		break;
	    	case 1:
	    		String strconcat="000";
	    		str= strconcat.concat(str);	    	
	    	break;
	    	case 2:
	    		String strconcat1="00";
	    		str= strconcat1.concat(str);	    	
	    	break;
	    	case 3:
	    		String strconcat2="0";
	    		str= strconcat2.concat(str);	   	
	    	break;
	    }
		return str.toUpperCase();
	    	
   }
protected String HexStringTo1Len(String str){
		
    	
    	if (str.length()>1)
    	{
    		str=str.substring(str.length()-1,str.length());
    	}
    	switch (str.length()){
		case 0:
			str= "0";	    	
		break;
		}
    	return str.toUpperCase();
  }
protected String HexStringTo2Len(String str){
	
	
	if (str.length()>2)
	{
		str=str.substring(str.length()-2,str.length());
	}
	switch (str.length()){
		case 0:
			str= "00";	    	
		break;
		case 1:
			String strconcat="0";
			str= strconcat.concat(str);	    	
		break;
	}
	return str.toUpperCase();
    	
}

	private void init_data() {
		//         
		set_context(ANGLES_PAR);
		mANGLES_PAR.isReaded=false;
		while (mANGLES_PAR.isReaded==false) {}
		
		mFNNAME_DAT.isReaded=false;
		set_context(FNNAME_DAT);
		while (mFNNAME_DAT.isReaded==false) {}

		set_context(FUNSET_PAR);
		mFUNSET_PAR.isReaded=false;
		//      
		while (mFUNSET_PAR.isReaded==false) {}

		set_context(SENSOR_DAT);
	}
	
	//  
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
      getMenuInflater().inflate(R.menu.main_menu, menu);
      return super.onCreateOptionsMenu(menu);
    }
    
    //    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
      switch (item.getItemId()) {
  		case R.id.main_menu_exit:
  		{
  			//TODO   !!!
  	    	// Stop the Bluetooth RFCOMM services
  	        if (mRfcommClient != null) mRfcommClient.stop();
  			finish();
  			break;
  		}
  		case R.id.main_menu_connect:
  		{
  			BTConnect();
  			break;
  		}
  		case R.id.main_menu_saveEEPROM:
  		{
  			//TODO     EEPROM
  			String toSend="";
  	    	toSend="!"+OP_COMP_NC+
  	    			HexStringTo2Len(Integer.toHexString(0))+
  	    			HexStringTo2Len(Integer.toHexString(OPCODE_EEPROM_PARAM_SAVE))+
  	    			'\r';
  	    	if ((toSend.length())==(mOP_COMP_NC.length+1)) {
  	    		sendMessage(toSend);
  	    	}
  			break;
  		}
      }
      return super.onOptionsItemSelected(item);
    }

	public void onStartTrackingTouch(SeekBar arg0) {
		// TODO Auto-generated method stub
		
	}

	public void onStopTrackingTouch(SeekBar arg0) {
		// TODO Auto-generated method stub
	}
	
	double roundResult (double d, int precise) {
		   precise = 10^precise;
		   //d = d*precise;
		   int i = (int)(d*precise);
		   return (double) i/precise;
		}
	
	private int hex2SignedInt (String str, int start, int end){
		int result=0;
		int maxValue=(int)(Math.pow(2, (end-start)*4))/2;
		//Log.i("hex2SignedInt",Integer.toString(maxValue));
		result=Integer.parseInt(str.substring(start,end),16);
		//result= (int) new BigInteger(str.substring(start,end), 16).intValue();
		if (result>=maxValue){
			result=(maxValue*2-result)*(-1);
		}
		 
		
		return result;
	}
	
	class InitAfterConnect extends AsyncTask<Void, Void, String> {
	    
	    @Override
	    protected String doInBackground(Void... noargs) {
	    	init_data();
	        return "OK";
	    }

	    @Override
	    protected void onPostExecute(String result) {
	    	//   
	    	myPlusMinusControl1.setValue((double)mANGLES_PAR.OCTAN_CORR);
	    	
	    	//TODO
	    	// spinner     (  )
	    	mspinnerSelectMap.setSelection(mFUNSET_PAR.CURR_F_B);
	    	ArrayAdapter<String> madapter = (ArrayAdapter<String>) mspinnerSelectMap.getAdapter();
	    	madapter.notifyDataSetChanged();
	    	//  
	    	//mspinnerSelectMap.notifyAll();
	    	//mtextViewTest.setText(result);
	    	//mtextViewTest.setText(Charset.availableCharsets().toString());
	    	//Log.i("AvailableCharsets",Charset.availableCharsets().toString());
	    }
	}
	
	public char DecodeCP866toUnicode( byte cp866Char){
		int unsigned = UByte(cp866Char);
		char [] decodeArray = new char [] {
				  0x0000	/*NULL*/
				, 0x0001	/*START OF HEADING*/
				, 0x0002	/*/*START OF TEXT*/
				, 0x0003	/*/*END OF TEXT*/
				, 0x0004	/*/*END OF TRANSMISSION*/
				, 0x0005	/*ENQUIRY*/
				, 0x0006	/*ACKNOWLEDGE*/
				, 0x0007	/*BELL*/
				, 0x0008	/*BACKSPACE*/
				, 0x0009	/*HORIZONTAL TABULATION*/
				, 0x000a	/*LINE FEED*/
				, 0x000b	/*VERTICAL TABULATION*/
				, 0x000c	/*FORM FEED*/
				, 0x000d	/*CARRIAGE RETURN*/
				, 0x000e	/*SHIFT OUT*/
				, 0x000f	/*SHIFT IN*/
				, 0x0010	/*DATA LINK ESCAPE*/
				, 0x0011	/*DEVICE CONTROL ONE*/
				, 0x0012	/*DEVICE CONTROL TWO*/
				, 0x0013	/*DEVICE CONTROL THREE*/
				, 0x0014	/*DEVICE CONTROL FOUR*/
				, 0x0015	/*NEGATIVE ACKNOWLEDGE*/
				, 0x0016	/*SYNCHRONOUS IDLE*/
				, 0x0017	/*END OF TRANSMISSION BLOCK*/
				, 0x0018	/*CANCEL*/
				, 0x0019	/*END OF MEDIUM*/
				, 0x001a	/*SUBSTITUTE*/
				, 0x001b	/*ESCAPE*/
				, 0x001c	/*FILE SEPARATOR*/
				, 0x001d	/*GROUP SEPARATOR*/
				, 0x001e	/*RECORD SEPARATOR*/
				, 0x001f	/*UNIT SEPARATOR*/
				, 0x0020	/*SPACE*/
				, 0x0021	/*EXCLAMATION MARK*/
				, 0x0022	/*QUOTATION MARK*/
				, 0x0023	/*NUMBER SIGN*/
				, 0x0024	/*DOLLAR SIGN*/
				, 0x0025	/*PERCENT SIGN*/
				, 0x0026	/*AMPERSAND*/
				, 0x0027	/*APOSTROPHE*/
				, 0x0028	/*LEFT PARENTHESIS*/
				, 0x0029	/*RIGHT PARENTHESIS*/
				, 0x002a	/*ASTERISK*/
				, 0x002b	/*PLUS SIGN*/
				, 0x002c	/*COMMA*/
				, 0x002d	/*HYPHEN-MINUS*/
				, 0x002e	/*FULL STOP*/
				, 0x002f	/*SOLIDUS*/
				, 0x0030	/*DIGIT ZERO*/
				, 0x0031	/*DIGIT ONE*/
				, 0x0032	/*DIGIT TWO*/
				, 0x0033	/*DIGIT THREE*/
				, 0x0034	/*DIGIT FOUR*/
				, 0x0035	/*DIGIT FIVE*/
				, 0x0036	/*DIGIT SIX*/
				, 0x0037	/*DIGIT SEVEN*/
				, 0x0038	/*DIGIT EIGHT*/
				, 0x0039	/*DIGIT NINE*/
				, 0x003a	/*COLON*/
				, 0x003b	/*SEMICOLON*/
				, 0x003c	/*LESS-THAN SIGN*/
				, 0x003d	/*EQUALS SIGN*/
				, 0x003e	/*GREATER-THAN SIGN*/
				, 0x003f	/*QUESTION MARK*/
				, 0x0040	/*COMMERCIAL AT*/
				, 0x0041	/*LATIN CAPITAL LETTER A*/
				, 0x0042	/*LATIN CAPITAL LETTER B*/
				, 0x0043	/*LATIN CAPITAL LETTER C*/
				, 0x0044	/*LATIN CAPITAL LETTER D*/
				, 0x0045	/*LATIN CAPITAL LETTER E*/
				, 0x0046	/*LATIN CAPITAL LETTER F*/
				, 0x0047	/*LATIN CAPITAL LETTER G*/
				, 0x0048	/*LATIN CAPITAL LETTER H*/
				, 0x0049	/*LATIN CAPITAL LETTER I*/
				, 0x004a	/*LATIN CAPITAL LETTER J*/
				, 0x004b	/*LATIN CAPITAL LETTER K*/
				, 0x004c	/*LATIN CAPITAL LETTER L*/
				, 0x004d	/*LATIN CAPITAL LETTER M*/
				, 0x004e	/*LATIN CAPITAL LETTER N*/
				, 0x004f	/*LATIN CAPITAL LETTER O*/
				, 0x0050	/*LATIN CAPITAL LETTER P*/
				, 0x0051	/*LATIN CAPITAL LETTER Q*/
				, 0x0052	/*LATIN CAPITAL LETTER R*/
				, 0x0053	/*LATIN CAPITAL LETTER S*/
				, 0x0054	/*LATIN CAPITAL LETTER T*/
				, 0x0055	/*LATIN CAPITAL LETTER U*/
				, 0x0056	/*LATIN CAPITAL LETTER V*/
				, 0x0057	/*LATIN CAPITAL LETTER W*/
				, 0x0058	/*LATIN CAPITAL LETTER X*/
				, 0x0059	/*LATIN CAPITAL LETTER Y*/
				, 0x005a	/*LATIN CAPITAL LETTER Z*/
				, 0x005b	/*LEFT SQUARE BRACKET*/
				, 0x005c	/*REVERSE SOLIDUS*/
				, 0x005d	/*RIGHT SQUARE BRACKET*/
				, 0x005e	/*CIRCUMFLEX ACCENT*/
				, 0x005f	/*LOW LINE*/
				, 0x0060	/*GRAVE ACCENT*/
				, 0x0061	/*LATIN SMALL LETTER A*/
				, 0x0062	/*LATIN SMALL LETTER B*/
				, 0x0063	/*LATIN SMALL LETTER C*/
				, 0x0064	/*LATIN SMALL LETTER D*/
				, 0x0065	/*LATIN SMALL LETTER E*/
				, 0x0066	/*LATIN SMALL LETTER F*/
				, 0x0067	/*LATIN SMALL LETTER G*/
				, 0x0068	/*LATIN SMALL LETTER H*/
				, 0x0069	/*LATIN SMALL LETTER I*/
				, 0x006a	/*LATIN SMALL LETTER J*/
				, 0x006b	/*LATIN SMALL LETTER K*/
				, 0x006c	/*LATIN SMALL LETTER L*/
				, 0x006d	/*LATIN SMALL LETTER M*/
				, 0x006e	/*LATIN SMALL LETTER N*/
				, 0x006f	/*LATIN SMALL LETTER O*/
				, 0x0070	/*LATIN SMALL LETTER P*/
				, 0x0071	/*LATIN SMALL LETTER Q*/
				, 0x0072	/*LATIN SMALL LETTER R*/
				, 0x0073	/*LATIN SMALL LETTER S*/
				, 0x0074	/*LATIN SMALL LETTER T*/
				, 0x0075	/*LATIN SMALL LETTER U*/
				, 0x0076	/*LATIN SMALL LETTER V*/
				, 0x0077	/*LATIN SMALL LETTER W*/
				, 0x0078	/*LATIN SMALL LETTER X*/
				, 0x0079	/*LATIN SMALL LETTER Y*/
				, 0x007a	/*LATIN SMALL LETTER Z*/
				, 0x007b	/*LEFT CURLY BRACKET*/
				, 0x007c	/*VERTICAL LINE*/
				, 0x007d	/*RIGHT CURLY BRACKET*/
				, 0x007e	/*TILDE*/
				, 0x007f	/*DELETE*/
				, 0x0410	/*CYRILLIC CAPITAL LETTER A*/
				, 0x0411	/*CYRILLIC CAPITAL LETTER BE*/
				, 0x0412	/*CYRILLIC CAPITAL LETTER VE*/
				, 0x0413	/*CYRILLIC CAPITAL LETTER GHE*/
				, 0x0414	/*CYRILLIC CAPITAL LETTER DE*/
				, 0x0415	/*CYRILLIC CAPITAL LETTER IE*/
				, 0x0416	/*CYRILLIC CAPITAL LETTER ZHE*/
				, 0x0417	/*CYRILLIC CAPITAL LETTER ZE*/
				, 0x0418	/*CYRILLIC CAPITAL LETTER I*/
				, 0x0419	/*CYRILLIC CAPITAL LETTER SHORT I*/
				, 0x041a	/*CYRILLIC CAPITAL LETTER KA*/
				, 0x041b	/*CYRILLIC CAPITAL LETTER EL*/
				, 0x041c	/*CYRILLIC CAPITAL LETTER EM*/
				, 0x041d	/*CYRILLIC CAPITAL LETTER EN*/
				, 0x041e	/*CYRILLIC CAPITAL LETTER O*/
				, 0x041f	/*CYRILLIC CAPITAL LETTER PE*/
				, 0x0420	/*CYRILLIC CAPITAL LETTER ER*/
				, 0x0421	/*CYRILLIC CAPITAL LETTER ES*/
				, 0x0422	/*CYRILLIC CAPITAL LETTER TE*/
				, 0x0423	/*CYRILLIC CAPITAL LETTER U*/
				, 0x0424	/*CYRILLIC CAPITAL LETTER EF*/
				, 0x0425	/*CYRILLIC CAPITAL LETTER HA*/
				, 0x0426	/*CYRILLIC CAPITAL LETTER TSE*/
				, 0x0427	/*CYRILLIC CAPITAL LETTER CHE*/
				, 0x0428	/*CYRILLIC CAPITAL LETTER SHA*/
				, 0x0429	/*CYRILLIC CAPITAL LETTER SHCHA*/
				, 0x042a	/*CYRILLIC CAPITAL LETTER HARD SIGN*/
				, 0x042b	/*CYRILLIC CAPITAL LETTER YERU*/
				, 0x042c	/*CYRILLIC CAPITAL LETTER SOFT SIGN*/
				, 0x042d	/*CYRILLIC CAPITAL LETTER E*/
				, 0x042e	/*CYRILLIC CAPITAL LETTER YU*/
				, 0x042f	/*CYRILLIC CAPITAL LETTER YA*/
				, 0x0430	/*CYRILLIC SMALL LETTER A*/
				, 0x0431	/*CYRILLIC SMALL LETTER BE*/
				, 0x0432	/*CYRILLIC SMALL LETTER VE*/
				, 0x0433	/*CYRILLIC SMALL LETTER GHE*/
				, 0x0434	/*CYRILLIC SMALL LETTER DE*/
				, 0x0435	/*CYRILLIC SMALL LETTER IE*/
				, 0x0436	/*CYRILLIC SMALL LETTER ZHE*/
				, 0x0437	/*CYRILLIC SMALL LETTER ZE*/
				, 0x0438	/*CYRILLIC SMALL LETTER I*/
				, 0x0439	/*CYRILLIC SMALL LETTER SHORT I*/
				, 0x043a	/*CYRILLIC SMALL LETTER KA*/
				, 0x043b	/*CYRILLIC SMALL LETTER EL*/
				, 0x043c	/*CYRILLIC SMALL LETTER EM*/
				, 0x043d	/*CYRILLIC SMALL LETTER EN*/
				, 0x043e	/*CYRILLIC SMALL LETTER O*/
				, 0x043f	/*CYRILLIC SMALL LETTER PE*/
				, 0x2591	/*LIGHT SHADE*/
				, 0x2592	/*MEDIUM SHADE*/
				, 0x2593	/*DARK SHADE*/
				, 0x2502	/*BOX DRAWINGS LIGHT VERTICAL*/
				, 0x2524	/*BOX DRAWINGS LIGHT VERTICAL AND LEFT*/
				, 0x2561	/*BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE*/
				, 0x2562	/*BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE*/
				, 0x2556	/*BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE*/
				, 0x2555	/*BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE*/
				, 0x2563	/*BOX DRAWINGS DOUBLE VERTICAL AND LEFT*/
				, 0x2551	/*BOX DRAWINGS DOUBLE VERTICAL*/
				, 0x2557	/*BOX DRAWINGS DOUBLE DOWN AND LEFT*/
				, 0x255d	/*BOX DRAWINGS DOUBLE UP AND LEFT*/
				, 0x255c	/*BOX DRAWINGS UP DOUBLE AND LEFT SINGLE*/
				, 0x255b	/*BOX DRAWINGS UP SINGLE AND LEFT DOUBLE*/
				, 0x2510	/*BOX DRAWINGS LIGHT DOWN AND LEFT*/
				, 0x2514	/*BOX DRAWINGS LIGHT UP AND RIGHT*/
				, 0x2534	/*BOX DRAWINGS LIGHT UP AND HORIZONTAL*/
				, 0x252c	/*BOX DRAWINGS LIGHT DOWN AND HORIZONTAL*/
				, 0x251c	/*BOX DRAWINGS LIGHT VERTICAL AND RIGHT*/
				, 0x2500	/*BOX DRAWINGS LIGHT HORIZONTAL*/
				, 0x253c	/*BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL*/
				, 0x255e	/*BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE*/
				, 0x255f	/*BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE*/
				, 0x255a	/*BOX DRAWINGS DOUBLE UP AND RIGHT*/
				, 0x2554	/*BOX DRAWINGS DOUBLE DOWN AND RIGHT*/
				, 0x2569	/*BOX DRAWINGS DOUBLE UP AND HORIZONTAL*/
				, 0x2566	/*BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL*/
				, 0x2560	/*BOX DRAWINGS DOUBLE VERTICAL AND RIGHT*/
				, 0x2550	/*BOX DRAWINGS DOUBLE HORIZONTAL*/
				, 0x256c	/*BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL*/
				, 0x2567	/*BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE*/
				, 0x2568	/*BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE*/
				, 0x2564	/*BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE*/
				, 0x2565	/*BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE*/
				, 0x2559	/*BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE*/
				, 0x2558	/*BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE*/
				, 0x2552	/*BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE*/
				, 0x2553	/*BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE*/
				, 0x256b	/*BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE*/
				, 0x256a	/*BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE*/
				, 0x2518	/*BOX DRAWINGS LIGHT UP AND LEFT*/
				, 0x250c	/*BOX DRAWINGS LIGHT DOWN AND RIGHT*/
				, 0x2588	/*FULL BLOCK*/
				, 0x2584	/*LOWER HALF BLOCK*/
				, 0x258c	/*LEFT HALF BLOCK*/
				, 0x2590	/*RIGHT HALF BLOCK*/
				, 0x2580	/*UPPER HALF BLOCK*/
				, 0x0440	/*CYRILLIC SMALL LETTER ER*/
				, 0x0441	/*CYRILLIC SMALL LETTER ES*/
				, 0x0442	/*CYRILLIC SMALL LETTER TE*/
				, 0x0443	/*CYRILLIC SMALL LETTER U*/
				, 0x0444	/*CYRILLIC SMALL LETTER EF*/
				, 0x0445	/*CYRILLIC SMALL LETTER HA*/
				, 0x0446	/*CYRILLIC SMALL LETTER TSE*/
				, 0x0447	/*CYRILLIC SMALL LETTER CHE*/
				, 0x0448	/*CYRILLIC SMALL LETTER SHA*/
				, 0x0449	/*CYRILLIC SMALL LETTER SHCHA*/
				, 0x044a	/*CYRILLIC SMALL LETTER HARD SIGN*/
				, 0x044b	/*CYRILLIC SMALL LETTER YERU*/
				, 0x044c	/*CYRILLIC SMALL LETTER SOFT SIGN*/
				, 0x044d	/*CYRILLIC SMALL LETTER E*/
				, 0x044e	/*CYRILLIC SMALL LETTER YU*/
				, 0x044f	/*CYRILLIC SMALL LETTER YA*/
				, 0x0401	/*CYRILLIC CAPITAL LETTER IO*/
				, 0x0451	/*CYRILLIC SMALL LETTER IO*/
				, 0x0404	/*CYRILLIC CAPITAL LETTER UKRAINIAN IE*/
				, 0x0454	/*CYRILLIC SMALL LETTER UKRAINIAN IE*/
				, 0x0407	/*CYRILLIC CAPITAL LETTER YI*/
				, 0x0457	/*CYRILLIC SMALL LETTER YI*/
				, 0x040e	/*CYRILLIC CAPITAL LETTER SHORT U*/
				, 0x045e	/*CYRILLIC SMALL LETTER SHORT U*/
				, 0x00b0	/*DEGREE SIGN*/
				, 0x2219	/*BULLET OPERATOR*/
				, 0x00b7	/*MIDDLE DOT*/
				, 0x221a	/*SQUARE ROOT*/
				, 0x2116	/*NUMERO SIGN*/
				, 0x00a4	/*CURRENCY SIGN*/
				, 0x25a0	/*BLACK SQUARE*/
				, 0x00a0	/*NO-BREAK SPACE*/
		};
		
		return decodeArray[unsigned];
		
	}
	
	// signed to unsigned
	private int UByte(byte b){
    	if(b<0) // if negative
    		return (int)( (b&0x7F) + 128 );
    	else
    		return (int)b;
    }
	
	
	private Runnable mUpdateTimeTask = new Runnable() {
        public void run() {
//            long millis = SystemClock.uptimeMillis();

        	UpdateUI();
            // add a delay to adjust for computation time
           // long delay = (1000 - (elapseTime%1000));
        	
            mHandlerToUpdteUI.postDelayed(this, 100);
        }
     };

	protected void UpdateUI() {
		// TODO Auto-generated method stub
		mProgressBarMAP.setProgress(mSENSOR_DAT.AIR);
		mtextViewAirFlow.setText("Air Flow(" + Integer.toString(mSENSOR_DAT.AIR) + ")");
		
		//     2-    ()
		DecimalFormat df2 = new DecimalFormat("#0.00");
		//mtextViewTest.setText(Float.toString(mSENSOR_DAT.UBAT)+" V\r"+Float.toString(mSENSOR_DAT.TEMP)+" C");
		mTextViewBatteyValue.setText(df2.format(mSENSOR_DAT.UBAT)+" V");
		mTextViewTempValue.setText(df2.format(mSENSOR_DAT.TEMP)+" C");
		mViewAdvanceAngle.setText(df2.format(mSENSOR_DAT.AA)+"");
	}
	
}
